#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire500seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire500seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven5004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven5004xi = {
                1:'-105x-194y448z',
                2:'-10x-13y499z',
                3:'-10x-60y496z',
                4:'-110x-423y240z',
                5:'-113x-184y450z',
                6:'-120x-174y452z',
                7:'-123x-461y146z',
                8:'-126x-164y454z',
                9:'-12x-18y499z',
                10:'-12x-55y496z',
                11:'-132x-154y456z',
                12:'-132x-415y245z',
                13:'-136x-143y458z',
                14:'-139x-25y479z',
                15:'-13x-22y499z',
                16:'-140x-133y460z',
                17:'-142x-34y477z',
                18:'-144x-122y462z',
                19:'-145x-42y476z',
                20:'-146x-112y464z',
                21:'-147x-453y151z',
                22:'-147x-52y474z',
                23:'-148x-101y466z',
                24:'-149x-61y473z',
                25:'-149x-71y471z',
                26:'-149x-91y468z',
                27:'-14x-28y498z',
                28:'-14x-49y497z',
                29:'-150x-81y469z',
                30:'-152x-405y249z',
                31:'-15x-33y498z',
                32:'-15x-38y498z',
                33:'-15x-44y497z',
                34:'-170x-443y155z',
                35:'-172x-394y253z',
                36:'-191x-161y433z',
                37:'-192x-382y258z',
                38:'-192x-432y160z',
                39:'-195x-148y435z',
                40:'-199x-135y437z',
                41:'-1x-1y499z',
                42:'-1x-76y494z',
                43:'-202x-122y440z',
                44:'-204x-109y442z',
                45:'-206x-96y444z',
                46:'-207x-84y447z',
                47:'-20x-255y429z',
                48:'-20x-447y223z',
                49:'-210x-369y262z',
                50:'-214x-420y165z',
                51:'-222x-208y516z',
                52:'-228x-356y266z',
                53:'-235x-407y170z',
                54:'-245x-341y270z',
                55:'-255x-392y174z',
                56:'-255x-429y1z',
                57:'-25x-482y127z',
                58:'-260x-326y274z',
                59:'-274x-377y179z',
                60:'-275x-309y279z',
                61:'-277x-415y6z',
                62:'-289x-293y283z',
                63:'-292x-361y184z',
                64:'-299x-400y11z',
                65:'-302x-275y287z',
                66:'-309x-344y188z',
                67:'-314x-257y291z',
                68:'-319x-384y16z',
                69:'-324x-238y295z',
                70:'-326x-326y193z',
                71:'-334x-220y299z',
                72:'-339x-366y21z',
                73:'-33x-249y431z',
                74:'-341x-307y198z',
                75:'-342x-200y303z',
                76:'-350x-181y307z',
                77:'-355x-287y202z',
                78:'-356x-161y311z',
                79:'-357x-348y26z',
                80:'-361x-141y315z',
                81:'-365x-121y319z',
                82:'-368x-100y323z',
                83:'-368x-267y207z',
                84:'-369x-80y326z',
                85:'-375x-329y31z',
                86:'-379x-246y211z',
                87:'-390x-225y216z',
                88:'-391x-308y36z',
                89:'-399x-203y220z',
                90:'-406x-287y41z',
                91:'-407x-181y225z',
                92:'-414x-159y229z',
                93:'-420x-136y234z',
                94:'-421x-265y46z',
                95:'-424x-113y238z',
                96:'-427x-90y242z',
                97:'-429x-45y251z',
                98:'-429x-67y247z',
                99:'-433x-243y51z',
                100:'-43x-443y227z',
                101:'-445x-219y56z',
                102:'-455x-195y61z',
                103:'-45x-243y434z',
                104:'-464x-171y65z',
                105:'-472x-146y70z',
                106:'-478x-121y75z',
                107:'-4x-4y499z',
                108:'-4x-71y494z',
                109:'-50x-479y132z',
                110:'-57x-236y436z',
                111:'-66x-437y231z',
                112:'-68x-229y439z',
                113:'-75x-474y136z',
                114:'-78x-221y441z',
                115:'-7x-260y426z',
                116:'-7x-66y495z',
                117:'-7x-9y499z',
                118:'-88x-212y443z',
                119:'-89x-431y236z',
                120:'-97x-203y446z',
                121:'-99x-469y141z',
                122:'0x-484y122z'}
         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire500seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire500seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE500SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE500SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE500SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE500SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE500SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven5004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE500SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE500SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE500SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven5004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven5004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE500SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE500SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE500SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire500seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       